package de.intevation.artifactdatabase.rest;

import de.intevation.artifacts.ArtifactDatabase;
import de.intevation.artifacts.ArtifactNamespaceContext;

import org.restlet.data.MediaType;

import org.restlet.resource.ResourceException;

import org.restlet.ext.xml.DomRepresentation;

import org.restlet.representation.Representation;

import de.intevation.artifactdatabase.XMLUtils;
import de.intevation.artifactdatabase.XMLUtils.ElementCreator;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.log4j.Logger;

/**
 * @author <a href="mailto:sascha.teichmann@intevation">Sascha L. Teichmann</a>
 */
public class FactoriesResource
extends      BaseResource
{
    private static Logger logger = Logger.getLogger(FactoriesResource.class);

    public static final String PATH = "/factories";

    protected Representation innerGet()
    throws                   ResourceException
    {
        Document document = XMLUtils.newDocument();

        ElementCreator ec = new ElementCreator(
            document,
            ArtifactNamespaceContext.NAMESPACE_URI,
            ArtifactNamespaceContext.NAMESPACE_PREFIX);

        ArtifactDatabase db = (ArtifactDatabase)getContext()
            .getAttributes().get("database");

        Element root = ec.create("result");
        document.appendChild(root);

        Element type = ec.create("type");
        ec.addAttr(type, "name", "factory-list");
        root.appendChild(type);

        Element factories = ec.create("factories");
        root.appendChild(factories);

        String [][] factoryNames = db.artifactFactoryNamesAndDescriptions();

        for (int i = 0; i < factoryNames.length; ++i) {
            String [] nd = factoryNames[i];
            Element factoryElement = ec.create("factory");
            ec.addAttr(factoryElement, "name", nd[0]);
            ec.addAttr(factoryElement, "description", nd[1]);
            factories.appendChild(factoryElement);
        }

        document.normalizeDocument();

        return new DomRepresentation(
            MediaType.APPLICATION_XML, document);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
